function z=fct2D(x,y,function_type)

%-------------------------------------------------------------------------------
% FUNCTION DEFINITION. 
%-------------------------------------------------------------------------------
%
% INPUT:
%
% [x,y]: EVALUATE THE FUNCTION IN THE POINTS (x,y). "x", "y" ARE COLUMN VECTORS.
%
% [function_type]: PARAMETER THAT CHOOSES THE FUNCTION.
%
% OUTPUT:
%
% [z]: VALUE OF THE FUNCTION IN THE POINTS (x,y). IT IS A COLUMN VECTOR.
%
%-------------------------------------------------------------------------------

switch function_type
    
case 1
    z=.75*exp(-((9*x-2).^2 + (9*y-2).^2)/4) + ...
         .75*exp(-((9*x+1).^2)/49 - (9*y+1)/10) + ...
         .5*exp(-((9*x-7).^2 + (9*y-3).^2)/4) - ...
         .2*exp(-(9*x-4).^2 - (9*y-7).^2);
case 2
    z=( (x-0.5).^2 +(y-0.5).^2 ).^(1/2);
case 3
    z=(x+y).^20;                     % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN.
case 4
    loc_arg=(x-0.5).^2+(y-0.5).^2;
    z=exp(loc_arg);
case 5
    loc_arg=(x-0.5).^2+(y-0.5).^2;
    z=exp(-100*loc_arg);;
case 6
    z=cos(30*(x+y));
case 7
    z=ones(size(x));
case 8 
    z=exp(x+y);                      % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN.
case 9
    den=1+16*(x.^2+y.^2); z=1./den;  % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN.
case 10
    z=(x.^2+y.^2).^(3/2);            % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN.
case 11
    z=exp(-x.^2-y.^2);               % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN.
case 12
    
    arg_z=(x.^2+y.^2);
    arg_z=arg_z+(1-abs(sign(arg_z)))*eps;
    arg_z=arg_z.^(-1);
    
    z=exp(-arg_z);                   % MODIFICATION OF AN EXAMPLE BY N. TREFETHEN. 
end

